package com.sxtvs.open.api.review.controller;

import com.sxtvs.open.api.review.service.impl.SSEService;
import com.sxtvs.open.core.auth.LoginRequired;
import jakarta.annotation.Resource;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.servlet.mvc.method.annotation.SseEmitter;

@RestController
@RequestMapping("/user")
public class SseController {

    @Resource
    private SSEService sseService;

    @GetMapping(path = "/sse", produces = MediaType.TEXT_EVENT_STREAM_VALUE)
    @LoginRequired
    public SseEmitter handleSse() {
        SseEmitter sseEmitter = new SseEmitter(30_000L); // 设置超时时间
        sseService.monitor(sseEmitter);
        return sseEmitter;
    }
}
